package java_book.bag;

import java.util.ArrayList;

public class Bag<T> implements BagInterface<T>{
	private static int numberOfItems;
	private final int size = 100;
	
	private ArrayList<T> items;
	
	public Bag() {
		numberOfItems = 0;
		items = new ArrayList<T>(size);
	}
	@Override
	public int getCurrentSize() {
		return this.numberOfItems;
	}

	@Override
	public boolean isFull() {
		if (numberOfItems == size) {
			return true;
		}
		return false;
	}

	@Override
	public boolean isEmpty() {
		if (numberOfItems == 0) {
			return true;
		}
		return false;
	}

	@Override
	public boolean add(T newEntry) {
		if (isFull()) {
			return false;
		} else {
			items.add(newEntry);
			numberOfItems++;
		}
		return true;
	}

	@Override
	public T remove() {
		T returnItem;
		if (numberOfItems == 0) {
			return null;
		}
		
		returnItem = items.remove(0);
		numberOfItems--;
		return returnItem;
	}

	@Override
	public boolean remove(T anEntry) {
		if (numberOfItems == 0) {
			return false;
		}
		items.remove(anEntry);
		numberOfItems--;
		return true;
	}

	@Override
	public void clear() {
		items.clear();
		numberOfItems = 0;
		
	}

	@Override
	public int getFrequencyOf(T anEntry) {
		int numFreq = 0;
		int i;
		for (i = 0; i < numberOfItems; i++) {
			if (anEntry == items.remove(i)) {
				numFreq++;
			}
		}
		return numFreq;
	}

	@Override
	public boolean contains(T anEntry) {
		int i;
		for (i = 0; i < numberOfItems; i++) {
			if (anEntry == items.remove(i)) {
				return true;
			}
		}
		return false;
	}

	@Override
	public T[] toArray() {
		// TODO Auto-generated method stub
		return (T[]) items.toArray();
	}

}
