package java_book.ch10;

import java_book.queue.*;
import java_book.node.*;

public class LinkedDeque<T> implements DequeInterface<T> {
	
	private Node<T> headNode;
	private Node<T> tailNode;
	
	public LinkedDeque() {
		headNode = null;
		tailNode = null;
	}

	@Override
	public void addToFront(T newEntry) {
		if (headNode == null) {
			headNode = new Node<T>(newEntry);
			tailNode = headNode;
			return;
		}
		Node<T> tempNode = headNode;
		Node<T> newNode = new Node<T>(newEntry);
		headNode = newNode;
		newNode.setNext(tempNode);
	}

	@Override
	public void addToBack(T newEntry) {
		if (tailNode == null) {
			tailNode = new Node<T>(newEntry);
			return;
		}
		
		Node<T> tempNode = tailNode;
		Node<T> newNode = new Node<T>(newEntry);
		tempNode.setNext(newNode);
		tailNode = newNode;
	}

	@Override
	public T removeFront() {
		if (headNode == null) {
			return null;
		}
		T data = headNode.getData();
		headNode = headNode.nextNode();
		return data;
	}

	@Override
	public T removeBack() {
		if (tailNode == null) {
			return null;
		}
		T data = tailNode.getData();
		
		//eventually want
		//tailNode = tailNode.prevNode();

		Node<T> tempNode = headNode;
		while (tempNode != null) {
			if (tempNode.nextNode().nextNode() == null) {
				tailNode = tempNode;
				break;
			}
			tempNode = tempNode.nextNode();
		}
		return data;
	}

	@Override
	public T getFront() {
		if (headNode == null) {
			return null;
		}
		return headNode.getData();
	}

	@Override
	public T getBack() {
		if (tailNode == null) {
			return null;
		}
		return tailNode.getData();
	}

	@Override
	public boolean isEmpty() {
		if (headNode == null) {
			return true;
		}
		return false;
	}

	@Override
	public void clear() {
		while (headNode != null) {
			headNode = headNode.nextNode();
		}	
	}

}
