package java_book.ch10;

import java_book.queue.*;
import java_book.node.*;

public class LinkedQueue<T> implements QueueInterface<T> {
	private Node<T> headNode;
	
	public LinkedQueue() {
		headNode = null;
	}
	
	@Override
	public void enqueue(T newEntry) {
		if (headNode == null) {
			headNode = new Node<T>(newEntry);
			return;
		}
		
		Node<T> tempNode = headNode;
		
		while (tempNode != null) {
			if (tempNode.nextNode() == null) {
				break;
			}
			tempNode = tempNode.nextNode();
		}
		Node<T> newNode = new Node<T>(newEntry);
		tempNode.setNext(newNode);
	}

	@Override
	public T deque() {
		T returnData = headNode.getData();
		headNode = headNode.nextNode();
		return returnData;
	}

	@Override
	public T getFront() {
		return headNode.getData();
	}

	@Override
	public boolean isEmpty() {
		if (headNode == null) {
			return true;
		}
		return false;
	}

	@Override
	public void clear() {
		while (headNode != null) {
			headNode = headNode.nextNode();
		}
	}

}
