package java_book.ch11;

import java_book.queue.*;
import java_book.node.*;

public class LinkedDeque<T> implements DequeInterface<T> {
	private DLNode<T> firstNode;
	private DLNode<T> lastNode;
	
	public LinkedDeque() {
		firstNode = null;
		lastNode = null;
	}
	
	@Override
	public void addToFront(T newEntry) {
		DLNode<T> newNode = new DLNode<T>(newEntry, firstNode, null);
		
		if (isEmpty()) {
			lastNode = newNode;
		} else {
			firstNode.setPrevNode(newNode);
		}
		firstNode = newNode;
	}

	@Override
	public void addToBack(T newEntry) {
		DLNode<T> newNode = new DLNode<T>(newEntry, null, lastNode);
		
		if (isEmpty()) {
			firstNode = newNode;
		} else {
			lastNode.setNextNode(newNode);
		}
		lastNode = newNode;
	}

	@Override
	public T removeFront() {
		T front = null;
		
		if (!isEmpty()) {
			front = firstNode.getData();
			firstNode = firstNode.getNextNode();
			
			if (firstNode == null) {
				lastNode = null;
			} else {
				firstNode.setPrevNode(null);
			}
		}
		return front;
	}

	@Override
	public T removeBack() {
		T back = null;
		
		if (!isEmpty()) {
			back = lastNode.getData();
			lastNode = lastNode.getPrevNode();
			
			if (lastNode == null) {
				firstNode = null;
			} else {
				lastNode.setNextNode(null);
			}
		}
		return back;
	}

	@Override
	public T getFront() {
		return firstNode.getData();
	}

	@Override
	public T getBack() {
		return lastNode.getData();
	}

	@Override
	public boolean isEmpty() {
		if (firstNode == null && lastNode == null) {
			return true;
		}
		return false;
	}

	@Override
	public void clear() {
		firstNode = null;
		lastNode = null;
	}

}
