package java_book.ch11;

import java_book.node.Node;
import java_book.queue.QueueInterface;

public class LinkedQueue<T> implements QueueInterface<T> {
	private Node<T> firstNode;	// references node at front of queue
	private Node<T> lastNode;	// references node at back of queue
	
	public LinkedQueue() {
		firstNode = null;
		lastNode = null;
	}

	@Override
	public void enqueue(T newEntry) {
		Node<T> newNode = new Node<T>(newEntry, null);
		
		if (isEmpty()) {
			firstNode = newNode;
		} else {
			lastNode.setNext(newNode);
		}
		lastNode = newNode;
		
	}

	@Override
	public T deque() {
		T front = null;
		if (!isEmpty()) {
			front = firstNode.getData();
			firstNode = firstNode.nextNode();
			
			if (firstNode == null) {
				lastNode = null;
			}
		}
		return front;
	}

	@Override
	public T getFront() {
		T front = null;
		
		if (!isEmpty()) {
			front = firstNode.getData();
		}
		
		return front;
	}

	@Override
	public boolean isEmpty() {
		if (firstNode == null && lastNode == null) {
			return true;
		}
		return false;
	}

	@Override
	public void clear() {
		firstNode = null;
		lastNode = null;
	}

}
