package java_book.ch11;

import java.util.Vector;

import java_book.queue.*;

/**
 * A class that implements a queue of objects by using a vector
 * @author mark
 *
 * @param <T>
 */
public class VectorQueue<T> implements QueueInterface<T> {
	private Vector<T> queue; // queue's front entry is first in the vector
	
	public VectorQueue() {
		queue = new Vector<T>(); // vector doubles in size if necessary
	}
	
	public VectorQueue(int initialCapacity) {
		queue = new Vector<T>(initialCapacity);
	}

	@Override
	public void enqueue(T newEntry) {
		queue.add(newEntry);
	}

	@Override
	public T deque() {
		T front = null;
		
		if (!isEmpty()) {
			front = queue.remove(0);
		}
		
		return front;
	}

	@Override
	public T getFront() {
		T front = null;
		
		if (!isEmpty()) {
			front = queue.get(0);
		}
		
		return front;
	}

	@Override
	public boolean isEmpty() {
		if (queue.isEmpty()) {
			return true;
		}
		return false;
	}

	@Override
	public void clear() {
		queue.clear();
	}

}
