package java_book.ch2;

import java_book.ArrayBag.*;
import java_book.bag.BagInterface;

/**
 * A test of the methods add, toArray, and isFull, as defined
 * in the first draft of the class ArrayBag.
 * @author mark
 *
 */
public class ArrayBagDemo1 {
	public static void main(String[] args) {
		// a bag that is not full
		BagInterface<String> aBag = new ArrayBag<String>();
		
		// test on an empty bag
		testIsFull(aBag, false);
		
		// adding strings
		String[] contentsOfBag1 = {"A", "A", "B", "A", "C", "A"};
		testAdd(aBag, contentsOfBag1);
		testIsFull(aBag, false);
		
		// a bag that will be full
		aBag = new ArrayBag<String>(7);
		System.out.println("\nA new empty bag:");
		
		//tests on an empty bag
		testIsFull(aBag, false);
		
		// adding strings
		String[] contentsOfBag2 = {"A", "B", "A", "C", "B", "C", "D"};
		testAdd(aBag, contentsOfBag2);
		testIsFull(aBag, true);
	}
	
	/**
	 * Tests the method add
	 * @param aBag
	 * @param content
	 */
	private static void testAdd(BagInterface<String> aBag, String[] content) {
		int index;
		int size = content.length;
		System.out.print("Adding to the bag: ");
		for (index = 0; index < size; index++) {
			aBag.add(content[index]);
			System.out.print(content[index] + " ");
		}
		System.out.println();
		
		displayBag(aBag);
	}
	
	/**
	 * Tests the method isFull
	 * @param aBag
	 * @param correctResult indicates what isFull should return
	 */
	private static void testIsFull(BagInterface<String> aBag, boolean correctResult) {
		System.out.print("\nTesting the moethod isFull with ");
		if (correctResult) {
			System.out.println("a full bag:");
		} else {
			System.out.println("a bag that is not full:");
		}
		
		System.out.print("isFull finds the bag ");
		if (correctResult && aBag.isFull()) {
			System.out.println("full: Ok.");
		} else if (correctResult) {
			System.out.println("not full, but it is full: ERROR.");
		} else if (!correctResult && aBag.isFull()) {
			System.out.println("full, but it is not full: ERROR.");
		} else {
			System.out.println("not full: OK");
		}
	}
	
	/**
	 * Test the method toArray while displaying the bag
	 * @param aBag
	 */
	private static void displayBag(BagInterface<String> aBag) {
		int length;
		
		System.out.println("The bag contains the following string(s):");
		Object[] bagArray = aBag.toArray();
		length = bagArray.length;
		for (int index = 0; index < length; index++) {
			System.out.print(bagArray[index] + " ");
		}
		
		System.out.println();
	}

}
