package java_book.ch6;

import java.util.Arrays;

import java_book.stack.StackInterface;;

public class ArrayStack<T> implements StackInterface<T> {
	
	private int topStackIndex;
	private T[] stack;
	private static final int DEFAULT_CAPACITY = 50;
	
	public ArrayStack() {
		this(DEFAULT_CAPACITY);
	}
	
	public ArrayStack(int capacity) {
		topStackIndex = 0;
		@SuppressWarnings("unchecked")
		T[] tempObject = (T[])new Object[capacity];
		
		this.stack = tempObject;
	}
	@Override
	public void push(T newEntry) {
		ensureCapacity();
		this.topStackIndex++;
		this.stack[topStackIndex] = newEntry;
	}
	
	public void ensureCapacity() {
		if (this.topStackIndex == this.stack.length - 1) {
			this.stack = Arrays.copyOf(stack, 2 * this.stack.length);
		}
	}

	@Override
	public T pop() {
		if (this.topStackIndex == 0) {
			return null;
		}
		T returnItem = this.stack[topStackIndex];
		this.stack[topStackIndex] = null;
		topStackIndex--;
		return returnItem;
	}

	@Override
	public T peek() {
		return this.stack[topStackIndex];
	} 

	@Override
	public boolean isEmpty() {
		if (this.topStackIndex == 0) {
			return true;
		} else {
			return false;
		}
	}

	@Override
	public void clear() {
		int i;
		int size = this.stack.length;
		for (i = 0; i < size; i++) {
			this.stack[i] = null;
		}
		topStackIndex = 0;
	}

}
