package java_book.ch6;

import java_book.stack.StackInterface;
import java.util.Vector;

/**
 * A class of stacks whose entries are stored in a vector
 * @author mark
 *
 * @param <T>
 */
public class VectorStack<T> implements StackInterface<T>{
	
	private Vector<T> stack; // last element is the top entry in stack
	private static final int DEFAULT_INITIAL_CAPACITY = 50;
	
	public VectorStack() {
		this(DEFAULT_INITIAL_CAPACITY);
	}
	
	public VectorStack(int initialCapacity) {
		this.stack = new Vector<T>(initialCapacity); // size doubles as needed
	}

	@Override
	public void push(T newEntry) {
		this.stack.add(newEntry);
	}

	@Override
	public T pop() {
		T top = null;
		
		if (!this.isEmpty()) {
			top = this.stack.remove(this.stack.size() - 1);
		}
		
		return top;
	}

	@Override
	public T peek() {
		T top = null;
		
		if (!this.isEmpty()) {
			top = this.stack.lastElement();
		}
		
		return top;
	}

	@Override
	public boolean isEmpty() {
		return this.stack.isEmpty();
	}

	@Override
	public void clear() {
		this.stack.clear();
	}

}
