package java_book.ch7;

import java_book.node.Node;
/**
 * A class that implements basic recursive functions.
 * @author mark
 *
 */
public class Recursion {
	public static void main(String[] args) {
		int result = fact(3);
		countDown(result);
		System.out.println(sumOf(result));
		
		int array[] = {1, 2, 3, 4, 5, 6};
		displayArray(array, 0, 5);
		System.out.println();
		
		Node<String> headNode = new Node<String>("one");
		Node<String> n1 = new Node<String>("two");
		Node<String> n2 = new Node<String>("tie your shoe!");
		
		headNode.setNext(n1);
		n1.setNext(n2);
		
		displayChain(headNode);
		
	}
	
	/**
	 * This function counts down from a given integer value
	 * @param integer
	 */
	public static void countDown(int integer) {
		if (integer == 1) {
			System.out.println(integer);
		} else {
			System.out.println(integer);
			countDown(integer - 1);
		}
	}
	
	/**
	 * This function implements the factorial formula:
	 * n*(n-1)*...*1
	 * @param n
	 * @return the factorila of n, i.e. n!
	 */
	public static int fact(int n) {
		if (n == 0) {
			return 1;
		} else {
			return n*fact(n-1);
		}
	}
	
	/**
	 * This function will sum up the integers up to n
	 * 1 + 2 + ... + n
	 * @param n
	 * @return
	 */
	public static int sumOf(int n) {
		int sum;
		
		if (n == 1) {
			sum = 1;
		} else {
			sum = sumOf(n-1) + n;
		}
		return sum;
	}
	
	/**
	 * This function uses recursion to display an array.
	 * @param array
	 * @param first
	 * @param last
	 */
	public static void displayArray(int array[], int first, int last) {
		if (first == last) {
			System.out.print(array[first] + ", ");
		} else {
			int mid = (first + last) / 2;
			displayArray(array, first, mid);
			displayArray(array, mid + 1, last);
		}
	}
	
	public static void displayChain(Node nodeOne) {
		if (nodeOne != null) {
			System.out.print(nodeOne.getData()+ " ");
			displayChain(nodeOne.nextNode());
		} else {
			System.out.println();
		}
	}
}
