package java_book.queue;

public interface DequeInterface<T> {
	
	/**
	 * This will and an element to the front of the queue
	 * @param newEntry
	 */
	public void addToFront(T newEntry);
	
	/**
	 * This will add an element to the back of the queue
	 * @param newEntry
	 */
	public void addToBack(T newEntry);
	
	/**
	 * This will remove an element from the front of the queue
	 * @return
	 */
	public T removeFront();
	
	/**
	 * This will remove an element from the back of the queue
	 * @return
	 */
	public T removeBack();
	
	/**
	 * This will get the element's data from the front of the queue
	 * @return
	 */
	public T getFront();
	
	/**
	 * This will get the element's data from the back of the queue
	 * @return
	 */
	public T getBack();
	
	/**
	 * This checks if the queue is empty
	 * @return Returns true if the queue is empty
	 */
	public boolean isEmpty();
	
	/**
	 * This will clear up the queue's data
	 */
	public void clear();

}
