package java_book.queue;

public interface QueueInterface<T> {
	
	/**
	 * Adds a new entry to the back of the queue
	 * @param newEntry is the new entry
	 */
	public void enqueue(T newEntry);
	
	/**
	 * Removes and returns the entry at the front of the queue
	 * @return Returns either the queue's front entry or,
	 * it the queue is empty before the operation, null
	 */
	public T deque();
	
	/**
	 * Retrieves the queue's front entry without
	 * changing the queue in any way.
	 * @return Returns either the queue's front entry
	 * or, if the queue is empty, null
	 */
	public T getFront();
	
	/**
	 * Detects whether the queue is empty
	 * @return Returns true if the queue is empty
	 */
	public boolean isEmpty();
	
	/**
	 * Removes all entries from the queue
	 */
	public void clear();

}
