package java_book.stack;

import java_book.node.Node;

public class OurStack<T> implements StackInterface<T> {
	
	Node<T> headNode;

	public OurStack() {
		this.headNode = null;
	}
	
	@Override
	public void push(T newEntry) {
		if (this.headNode == null) {
			headNode = new Node<T>(newEntry);
		} else {
			Node<T> newNode = new Node<T>(newEntry);
			headNode.setPrev(newNode);
			newNode.setNext(headNode);
			headNode = newNode;
		}
		
	}

	@Override
	public T pop() {
		if (headNode == null) {
			return null;
		}
		Node<T> returnNode = headNode;
		headNode = headNode.nextNode();
		return (T) returnNode.getData();
	}

	@Override
	public T peek() {
		if (headNode == null) {
			return null;
		}
		return (T) headNode.getData();
	}

	@Override
	public boolean isEmpty() {
		if (headNode == null) {
			return true;
		}
		return false;
	}

	@Override
	public void clear() {
		while (headNode != null) {
			headNode = headNode.nextNode();
		}
	}

}
